Arithmetic Slices

这两天一直复习动态规划,就想到leetcode上刷刷题,easy难度的很少,大部分都是medium和hard。本题是第一道DP类型medium难度的题目,但是用其他的方法比如暴力法也可以求解。首先来看题目描述:

A sequence of number is called arithmetic if it consists of at least three elements and if the difference between any two consecutive elements is the same.

For example, these are arithmetic sequence:

1, 3, 5, 7, 9
7, 7, 7, 7
3, -1, -5, -9

The following sequence is not arithmetic.

1, 1, 2, 5, 7

A zero-indexed array A consisting of N numbers is given. A slice of that array is any pair of integers (P, Q) such that 0 <= P < Q < N.

A slice (P, Q) of array A is called arithmetic if the sequence:
A[P], A[p + 1], ..., A[Q - 1], A[Q] is arithmetic. In particular, this means that P + 1 < Q.

The function should return the number of arithmetic slices in the array A.

Example:

A = [1, 2, 3, 4]

return: 3, for 3 arithmetic slices in A: [1, 2, 3], [2, 3, 4] and [1, 2, 3, 4] itself.

解题思路:

题目描述的很明确,包含至少三个数的序列,如果差分相等,那么这个序列就叫做arithmetic sequence,在一个数组里统计有多少个满足条件的序列(切片)。首先试试暴力法。我们固定一个最小长度为3的区间(i, j),如果差分相等,我们就右移j,一直到数组的末尾,满足条件的话计数加一。需要注意的是如果区间(i, j-1)是arithmetic slice,那么我们末尾加上一个j,如果A[j] - A[j-1] 等于之前的差分值,那么区间(i, j)也属于arithmetic slice,我们要避免每次判断都要计算前面的差分。代码如下:

class Solution(object):
    def numberOfArithmeticSlices(self, A):
        res = 0
        for i in range(len(A)-2):
            d = A[i+1] - A[i]
            for j in range(i+2, len(A)):
                if A[j] - A[j-1] == d:
                    res += 1
                else:
                    break
        return res

 当然我们可以用dp算法,令一维dp[i]表示以i结尾的区间有多少个arithmetic  slice,新添加的元素和前面元素的差,如果等于之前的差值,那么就让dp[i]加一。代码如下:

class Solution(object):
    def numberOfArithmeticSlices(self, A):
        dp = [0 for i in range(len(A))]
        res = 0
        for i in range(2, len(A)):
            if A[i] - A[i-1] == A[i-1] - A[i-2]:
                dp[i] = 1 + dp[i-1]
                res += dp[i]
        return res

我们可以优化空间复杂度,因为dp的更新只跟上一个元素有关,因此我们用一个变量空间来代替原来的数组。

class Solution(object):
    def numberOfArithmeticSlices(self, A):
        dp = 0
        res = 0
        for i in range(2, len(A)):
            if A[i] - A[i-1] == A[i-1] - A[i-2]:
                dp += 1
                res += dp
            else:
                dp = 0
        return res

 



posted @ 2017-08-31 18:59  Nicotine1026  阅读(132)  评论(0编辑  收藏  举报